import { Col, Row } from 'antd';
import React from 'react';
import error from '../assets/404.svg';

const NoFoundPage: React.FC<{ msg?: string }> = ({
  msg = '抱歉、你访问的页面不存在。',
}) => (
  <Row gutter={{ md: 8, lg: 24, xl: 48 }} style={{ marginTop: 50 }}>
    <Col md={8} sm={24} offset={2}>
      <img src={error} alt="error" />
    </Col>
    <Col md={8} sm={24} offset={2} style={{ marginTop: 70 }}>
      <h1 style={{ fontSize: 70, marginBottom: 20 }}>404</h1>
      <div style={{ fontSize: 20, color: 'rgba(0, 0, 0, .45)' }}>{msg}</div>
    </Col>
  </Row>
);

export default NoFoundPage;
